<template>
  <div style="height:100%;display:flex">

    <el-aside
      v-if="this.$store.state.aside"
      width="260px"
      style="background-color: rgb(238, 241, 246)"
    >
      <el-menu
        :default-openeds="openeds"
      >
        <el-submenu
          v-for="(item,index) in defaultData"
          :key="index"
          :index="(index+1).toString()"
          style="border-bottom:1px solid #eee;padding-left: 15px;"
          class="abc"
        >
          <template
            slot="title"
            class="title"
            style="padding-left:20px!important"
          >
            <!-- <i
                style="vertical-align: -2px;font-size: 20px;margin-right:5px"
                class="iconfont icongongsi"
              /> -->

            <!-- <el-button type="primary" circle /> -->
            {{ item.name }}
          </template>
          <el-menu-item
            v-for="(items,indexitem) in item.servicesScopes"
            :key="indexitem"
            style="display: flex;justify-content: space-between;align-items: center;padding-right: 0;padding-left:35px"
            :index="(index+1 + '-' + indexitem + 1).toString()"
            @click="jump(items)"
          >
            <span>{{ items.name }}</span>
            <i
              style="vertical-align: -2.5px;font-size: 20px;margin-right:10px;margin-left:auto"
              class="iconfont iconfaxianzuobiao"
            />
            <!-- </div> -->
          </el-menu-item>
        </el-submenu>
      </el-menu>
    </el-aside>
    <el-container style="position:relative">
      <canvas id="canvasMap" style="display: none;" />
      <div id="map" style="width:100%;height:100%" />
      <div class="top">
        <span
          v-for="(item, index) in params"
          :key="index"
          class="left"
          :class="{ click: changeColor == index }"
          @click="change(index)"
        >{{ item }}</span>
        <div style="float:right">
          <el-radio-group v-model="dateRadio" size="small" style="margin-left:20px">
            <el-radio-button label="小时" />
            <el-radio-button label="日报" />
            <el-radio-button label="月报" />
            <el-radio-button label="自定义" />
          </el-radio-group>
          <!-- <component :is="dataType" :value="currentCustomD" :class="{'w160':w160,'w400':w400}" style="padding-left:0;margin-left:10px" @sendPickerChild="showPickerChild" /> -->
          <TimePicker1 v-if="dataType==='TimePicker1'" :input-size="inputSize" :value1="currentHourD" :class="{'w160':w160,}" @sendPickerChild="showPickerChild" />
          <HourPicker1 v-else-if="dataType==='HourPicker1'" :value1="currentDayD" :class="{'w160':w160,}" @sendPickerChild="showPickerChild" />
          <DatePicker1 v-else-if="dataType==='DatePicker1'" :value1="currentMonthD" :class="{'w160':w160,}" @sendPickerChild="showPickerChild" />
          <CustomPicker1 v-else :value1="currentCustomD" :class="{'w400':w400,}" @sendPickerChild="showPickerChild" />
          <el-button type="primary" @click="clickGetData()">查询</el-button>
        </div>
      </div>
    </el-container>
    <!-- <baidu-map id="main" style="width:100%;height:100%" /> -->
  </div>
</template>

<script>
// import 'leaflet/dist/leaflet.css'
// import L from 'leaflet'
import 'leaflet/dist/leaflet.css'
import L from 'leaflet'
import 'leaflet-rotatedmarker/leaflet.rotatedMarker.js'
// import esri from 'esri-leaflet/dist/esri-leaflet'
import $ from 'jquery'
// import * as echarts from 'echarts'
import 'echarts/extension/bmap/bmap'
import { kriging } from '@/utils/kriging.js'
import TimePicker1 from '@/components/Form/TimePicker1'
import HourPicker1 from '@/components/Form/HourPicker1'
import DatePicker1 from '@/components/Form/DatePicker1'
import CustomPicker1 from '@/components/Form/CustomPicker1'
export default {
  components: {
    TimePicker1,
    HourPicker1,
    DatePicker1,
    CustomPicker1
  },
  data() {
    return {
      map: null,
      cellSizeCoord: [],
      latExtent: [],
      lngExtent: [],
      response: null,
      pointsData: [],
      extentData: [],
      valuesData: [],
      params: [
        'PM10',
        'PM2.5',
        'SO2',
        'NO2',
        'CO',
        'O3',
        'TVOC'
      ],
      changeColor: 0,
      sensorKey: 'a34002',
      currentDate: '',
      dataType: 'TimePicker1',
      dateRadio: '小时',
      unit: 'hourly',
      w160: true,
      w400: false,
      currentHourD: '',
      currentDayD: '',
      currentMonthD: '',
      currentCustomD: [],
      inputSize: 'small',
      resTimes: 0,
      isArray: false,
      responseArray: null,
      starInterval: null,
      defaultData: [],
      openeds: [],
      currentServicesScopeId: 0
    }
  },
  watch: {
    // 日期切换组件
    dateRadio(nv, ov) {
      this.w160 = true
      this.w400 = false
      if (nv === '小时') {
        this.dataType = 'TimePicker1'
        this.unit = 'hourly'
        this.currentHour()
      } else if (nv === '日报') {
        this.dataType = 'HourPicker1'
        this.unit = 'daily'
        this.currentDay()
      } else if (nv === '月报') {
        this.dataType = 'DatePicker1'
        this.unit = 'monthly'
        this.currentMonth()
      } else {
        this.dataType = 'CustomPicker1'
        this.unit = 'custom'
        this.w160 = !this.w160
        this.w400 = !this.w400
        // this.currentTime()
      }
    },
    // 监听定时器走完数据条数后清除
    resTimes(nv, ov) {
      if (nv === this.responseArray.length) {
        clearInterval(this.starInterval)
        this.resTimes = 0
        this.responseArray = []
      }
    }
  },
  mounted() {
    this.$nextTick(() => {
      this.clickGetData()
    })
  },
  beforeDestroy() {
    // this.map && this.map.destroy()
  },
  created() {
    this.currentHour()
    this.getOriList()
    // this.currentDay()
    // this.currentMonth()
  },
  methods: {
    // 获得子组件时间选择器传递的数据
    showPickerChild(data) {
      if (typeof data === Array) {
        this.currentCustomD = data
      } else {
        this.currentHourD = data
        this.currentDayD = data
        this.currentMonthD = data
      }
      this.currentDate = data
    },
    clickGetData() {
      this.getData().then(() => {
        if (this.dataType === 'CustomPicker1') {
          this.starInterval = setInterval(() => {
            this.initMap()
            // console.log('执行播放')
          }, 2000)
        } else {
          // console.log('执行单条')
          this.initMap()
        }
      })
    },
    // 组织图例列表，请求获得左侧列表数据
    getOriList() {
      this.$request({
        url: '/serviceScope/getDataByOrgIdAndCondition',
        method: 'get',
        params: {
          organization_id: this.$store.state.orgId
        }
      }).then((res) => {
        // console.log('/serviceScope/getDataByOrgIdAndCondition')
        // console.log(res)
        this.defaultData = res.data
        this.currentServicesScopeId = this.defaultData[0].servicesScopes[0].id
      }).catch((err) => {
        console.log(err)
      })
    },
    // 获取数据
    getData() {
      this.response = null
      return this.$request({
        url: '/chart/getThermodynamicDiagramDataByConditionV2',
        method: 'get',
        params: {
          servicesScopeId: this.currentServicesScopeId,
          // organization_id: 44,
          sensor_code: this.sensorKey,
          type: this.unit,
          time: typeof this.currentDate === 'string' ? this.currentDate : null,
          startTime: typeof this.currentDate === 'string' ? null : this.currentDate[0],
          endTime: typeof this.currentDate === 'string' ? null : this.currentDate[1]
        }
      })
        .then((res) => {
          // console.log('getThermodynamicDiagramDataByConditionV2')
          // console.log(res)
          var response = res.data
          // if (response instanceof Array) {
          // this.response = res.data.data
          // } else {
          this.response = res.data
          // }
          // if (response instanceof Array) {
          //   this.response = res.data.data[this.resTimes]
          //   this.resTimes += 1
          //   console.log('执行第' + this.resTimes + '次')
          // } else {
          //   this.response = res.data.data
          // }
        }).catch((err) => {
          console.log(err)
        })
    },
    // 渲染地图
    initMap() {
      const that = this
      // if (this.map) {
      // console.log('初始化map对象')
      // this.map = null
      this.pointsData = []
      this.valuesData = []
      if (this.map) {
        // map.eachLayer 移除除底图外的所有图层
        this.map.eachLayer(function(layer) {
          // 卸载之前的风场图层
          if (!layer._container && ('' + $(layer._container).attr('class')).replace(/\s/g, '') !== 'leaflet-layer') {
            layer.remove()
            // console.log('卸载之前的图层')
          }
        })
      }
      // }
      if (this.response instanceof Array) {
        this.isArray = true
        this.responseArray = JSON.parse(JSON.stringify(this.response))
      }
      // if (this.response instanceof Array) {
      //   this.response = this.response[this.resTimes]
      //   if (this.resTimes < this.response.length) this.resTimes += 1
      //   else this.resTimes = 0
      //   console.log('执行第' + this.resTimes + '次')
      // } else {
      //   this.response = this.response
      // }
      // return
      if (this.isArray) {
        if (this.resTimes < this.responseArray.length) {
          this.response = this.responseArray[this.resTimes]
          this.resTimes += 1
        }
        // if (this.resTimes > this.responseArray.length) {
        //   this.resTimes = 0
        // }
      } else {
        this.response = this.response
      }
      console.log(this.response, 'this.response')
      if (this.response.list && this.response.list.length < 1) {
        this.$message({
          message: '当前时间没有数据',
          type: 'warning'
        })
        clearInterval(this.starInterval)
      }
      if (!this.response.list) {
        return
      }
      for (let i = 0; i < this.response.list.length; i++) {
        // 范围内的设备点坐标
        this.pointsData.push(this.response.list[i].slice(0, 2))
        // 范围内的设备点状态
        this.valuesData.push(this.response.list[i].pop())
      }
      const points = this.pointsData
      const world = this.response.bound
      const values = this.valuesData
      // 获得数据后的业务逻辑
      if (!this.map) {
        this.map = L.map('map', {
          center: [38.65953686, 120.8696333],
          zoom: 9
        })
      }
      // 引入esri-leaflet, 还可按需引入，vue代码编译体积更小
      var esri = require('esri-leaflet')
      esri.tiledMapLayer({
        url: 'http://map.geoq.cn/ArcGIS/rest/services/ChinaOnlineCommunity/MapServer/tile/{z}/{y}/{x}'
      }).addTo(this.map)

      // world.js,是插值之后需要裁切的图形边界信息
      // point.js,是要插值的离散的点

      // 遍历world边界数据，生成scope边界线
      var positions = []
      world[0].forEach(function(point) {
        positions.push([point[1], point[0]])
      })
      var scope = L.polyline(positions, { color: '#409EFF' }).addTo(this.map)
      this.map.fitBounds(scope.getBounds())

      // 根据scope边界线的范围，计算范围变量
      var xlim = [scope.getBounds()._southWest.lng, scope.getBounds()._northEast.lng]
      var ylim = [scope.getBounds()._southWest.lat, scope.getBounds()._northEast.lat]

      // 进行克里金插值
      function loadkriging() {
        var canvas = document.getElementById('canvasMap')
        canvas.width = 1000
        canvas.height = 1000
        var n = points.length
        var t = []// 数值
        var x = []// 经度
        var y = []// 纬度
        for (var i = 0; i < n; i++) {
          x.push(points[i][0])
          y.push(points[i][1])
          L.circle([y[i], x[i]], { radius: 1 }).addTo(that.map)
        }

        // 对数据集进行训练
        var variogram = kriging.train(values, x, y, 'exponential', 0, 20)

        // 使用variogram对象使polygons描述的地理位置内的格网元素具备不一样的预测值,最后一个参数，是插值格点精度大小
        var grid = kriging.grid(world, variogram, (ylim[1] - ylim[0]) / 150)

        var colors = ['#00e400', '#ffff00', '#ff7e00', '#ff0000', '#99004c', '#7e0023']
        // 将得到的格网grid渲染至canvas上
        kriging.plot(canvas, grid, [xlim[0], xlim[1]], [ylim[0], ylim[1]], colors)
      }

      // 将canvas对象转换成image的URL
      function returnImgae() {
        var mycanvas = document.getElementById('canvasMap')
        return mycanvas.toDataURL('image/png')
      }

      loadkriging()

      var imageBounds = [[ylim[0], xlim[0]], [ylim[1], xlim[1]]]
      L.imageOverlay(returnImgae(), imageBounds, { opacity: 0.8 }).addTo(this.map)
    },
    /**
     * 获取数组中的最大值和最小值函数
     * */
    getMaxMin(arr, param) {
      try {
        if (param === 'max') {
          if (typeof (Math.max.apply(null, arr)) !== 'number') {
            return 'Error:element in arr is not a number!'
          } else {
            return Math.max.apply(null, arr)
          }
        } else if (param === 'min') {
          if (typeof (Math.min.apply(null, arr)) !== 'number') {
            return 'Error:element in arr is not a number!'
          } else {
            return Math.min.apply(null, arr)
          }
        } else {
          return 'Error:param is unsupported!'
        }
      } catch (e) {
        return 'Error:' + e
      }
    },
    renderItem(params, api) {
      const lngIndex = api.value(0)
      const latIndex = api.value(1)
      const pointLeftTop = this.getCoord(params, api, lngIndex, latIndex)
      const pointRightBottom = this.getCoord(params, api, lngIndex + 1, latIndex + 1)
      return {
        type: 'rect',
        shape: {
          x: pointLeftTop[0],
          y: pointLeftTop[1],
          width: pointRightBottom[0] - pointLeftTop[0],
          height: pointRightBottom[1] - pointLeftTop[1]
        },
        style: api.style({
          stroke: 'rgba(0,0,0,0)' // 笔画,网格线
        }),
        styleEmphasis: api.styleEmphasis() // 风格强调
      }
    },
    getCoord(params, api, lngIndex, latIndex) {
      var coords = params.context.coords || (params.context.coords = [])
      var key = lngIndex + '-' + latIndex

      // bmap returns point in integer, which makes cell width unstable.
      // 返回整数形式的点，这使得单元格宽度不稳定。
      // So we have to use right bottom point. 所以我们必须使用正确的底线
      return coords[key] || (coords[key] = api.coord([+(this.latExtent[0] + lngIndex * this.cellSizeCoord[0]).toFixed(6), +(this.lngExtent[0] + latIndex * this.cellSizeCoord[1]).toFixed(6)
      ]))
    },

    change(index) {
      this.changeColor = index
      var pr = ''
      switch (index) {
        case 0: pr = 'a34002'
          break
        case 1: pr = 'a34004'
          break
        case 2: pr = 'a21026'
          break
        case 3: pr = 'a21004'
          break
        case 4: pr = 'a21005'
          break
        case 5: pr = 'a05024'
          break
        case 6: pr = 'a99054'
          break
      }
      this.sensorKey = pr
      // this.initMap()
    },
    // 当前小时初始化
    currentHour() {
      var aData = new Date()
      var month = aData.getMonth() < 9 ? '0' + (aData.getMonth() + 1) : aData.getMonth() + 1
      var date = aData.getDate() <= 9 ? '0' + aData.getDate() : aData.getDate()
      var hour = aData.getHours() <= 9 ? '0' + aData.getHours() - 1 : aData.getHours()
      var currentDate = aData.getFullYear() + '-' + month + '-' + date + ' ' + hour
      this.currentHourD = currentDate.toString()
      this.currentDate = this.currentHourD
    },
    // 当日初始化
    currentDay() {
      var aData = new Date()
      var month = aData.getMonth() < 9 ? '0' + (aData.getMonth() + 1) : aData.getMonth() + 1
      var date = aData.getDate() < 9 ? '0' + aData.getDate() - 1 : aData.getDate()
      var currentDate = aData.getFullYear() + '-' + month + '-' + date
      this.currentDayD = currentDate.toString()
      this.currentDate = this.currentDayD
    },
    // 当月份初始化
    currentMonth() {
      var aData = new Date()
      var month = aData.getMonth() < 9 ? '0' + (aData.getMonth() + 1) : aData.getMonth()
      var currentDate = aData.getFullYear() + '-' + month
      this.currentMonthD = currentDate.toString()
      this.currentDate = this.currentMonthD
    },
    // 当前自定义初始化
    currentTime() {
      var aData = new Date()
      var month = aData.getMonth() < 9 ? '0' + (aData.getMonth() + 1) : aData.getMonth() + 1
      var date = aData.getDate() <= 9 ? '0' + aData.getDate() : aData.getDate()
      var currentDate = aData.getFullYear() + '-' + month + '-' + date
      this.currentCustomD = [currentDate, currentDate]
      this.currentDate = this.currentCustomD
    },
    // 父组件点击站点列表子组件跳转地图方法
    jump(items) {
      const newLL = [items.latitude, items.longitude]
      // const newLL = [items.centerLatitude, items.centerLongitude]
      this.jumpData = []
      this.jumpData.push(newLL[0])
      this.jumpData.push(newLL[1])
      // this.map.setView(this.jumpData, 18)
      this.currentServicesScopeId = items.id
    }
  }
}
</script>

<style lang="less" scoped>

#container {
  margin: 0;
  padding: 0;
  width: 100%;
  height: 100%;
}
.input-card .btn {
  margin-right: 1.2rem;
  width: 9rem;
}
.top {
  position: absolute;
  top: 0;
  width: 100%;
  padding: 5px 10px;
  z-index: 999;
  /* background: #ccc; */
  background: rgba(204, 204, 204, 0.5);
  box-shadow: 1px 1px 5px #666;
}
.top > .left {
  padding: 5px 10px;
  border: 1px solid #aaa;
  border-right: none;
  background: #fff;
  /* border-radius: 3px; */
  cursor: pointer;
  font-size: 16px;
  float: left;
  margin-top: 4px;
  -webkit-transform-origin-x: 0;
  /* -webkit-transform: scale(0.90); */
}
.top > .left:nth-child(1) {
  border-radius: 5px 0 0 5px;
}
.top > .left:nth-last-child(1) {
  border-radius: 0 5px 5px 0;
  border-right: 1px solid #aaa;
}
.top > .left:hover {
  background: #666;
  color: #fff;
}
.click {
  color: #fff;
  background-color: #666 !important;
}
.w160{
  width: 160px;
}
.w400{
  width: 400px;
}

.title {
  padding: 0 20px;
}
</style>
